Ext.define('dashboard.widget.Placeholder', {extend:'Ext.Container', alias:'widget.dashboardPlaceholderWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'DASHBOARD_PLACEHOLDER_WIDGET_NAME', WIDGET_DESCRIPTION:'DASHBOARD_PLACEHOLDER_WIDGET_DESCRIPTION', WIDGET_ICON_CLS:'x-fal fa-plus'}, layout:{type:'vbox', pack:'center', align:'middle'}, config:{widgetConfiguration:{title:'Dashboard Widget'}}, initComponent:function() {
  var me = this;
  me.items = [{xtype:'button', iconCls:BpcCommon.Icons.ADD, handler:'openSelectorWindow', columnIndex:me.columnIndex, bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashbaord + '}'}}, {xtype:'box', html:'\x3ch3\x3e' + BpcCommon.lang.Current.DASHBOARD_WIDGET_ADD_DESCRIPTION + '\x3c/h3\x3e'}];
  this.callParent();
}});
Ext.define('dashboard.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['dashboard.widget.Placeholder'], config:{moduleConfigurationComponents:[], widgets:['dashboard.widget.Placeholder']}});
Ext.define('dashboard.Module', {singleton:true, constructor:function() {
  Ext.log('Loading Dashboard Module...');
}});
Ext.define('dashboard.assets.ConfigKeys', {singleton:true, cfg:'configuration', colLayout:'layout_config', columns:'numberOfColumns', description:'module_description', moduleIconCls:'module_iconCls', moduleName:'module_name', moduleShowHeader:'module_showHeader', responsive:'module_isResponsive', widgetMove:'function_widgetMove', widgetJump:'function_widgetJump', widgetRefresh:'function_widgetRefresh', widgetInfo:'function_widgetInfo', toolbarRefresh:'function_toolbarRefresh'});
Ext.define('dashboard.assets.Icons', {singleton:true, autoRefreshIcon:'x-fal fa-sync', DASHBOARD:'x-fal fa-desktop', WIDGET:'x-fal fa-tachometer-alt'});
Ext.define('dashboard.assets.ModuleRights', {singleton:true, editDashbaord:'bpcDashboard_editDashboard'});
Ext.define('dashboard.view.DashboardColumn', {extend:'Ext.container.Container', alias:'widget.dbColumn', layout:{type:'vbox', align:'stretch'}, moduleId:undefined, initComponent:function() {
  Ext.log(this.self.getName() + ': initComponent');
  try {
    var responsive = BpcCommon.Api.getSetting(this.moduleId, dashboard.assets.ConfigKeys.responsive);
    if (responsive && responsive === true) {
      this.defaults = {flex:1};
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
  this.callParent(arguments);
}});
Ext.define('dashboard.view.Main', {extend:'Ext.panel.Panel', alias:'widget.dbMain', controller:'dashboardMainController', ui:'transparent', scrollable:true, header:false, iconCls:dashboard.assets.Icons.DASHBOARD, layout:'card', activeItem:0, applicationToolbarRight:undefined, numberOfColumns:undefined, moduleId:undefined, settingsForVmAndConfigPanel:[dashboard.assets.ConfigKeys.cfg, dashboard.assets.ConfigKeys.columns, dashboard.assets.ConfigKeys.colLayout, dashboard.assets.ConfigKeys.responsive, 
dashboard.assets.ConfigKeys.widgetInfo, dashboard.assets.ConfigKeys.widgetJump, dashboard.assets.ConfigKeys.widgetMove, dashboard.assets.ConfigKeys.widgetRefresh, dashboard.assets.ConfigKeys.toolbarRefresh], viewModel:{data:{autoUpdate:true, unsavedChanges:false}, stores:{}}, bpcSkipStateInjection:true, items:[], initComponent:function() {
  Ext.log({msg:this.self.getName() + ': initComponent'});
  var me = this;
  var vm = me.getViewModel();
  try {
    if (this.moduleId === 'dashboard') {
      this.items = [{xtype:'bpcCenterMessageCmp', message:'Dashboard', messageIconCls:'x-fal fa-desktop-alt'}];
      this.callParent();
      return;
    }
    this.getViewModel().set(dashboard.assets.ModuleRights.editDashbaord, BpcCommon.Api.hasUserRight(dashboard.assets.ModuleRights.editDashbaord));
    this.settings = [];
    Ext.Array.each(this.settingsForVmAndConfigPanel, this.setSettingToVMandSettingPanel.bind(this));
    this.numberOfColumns = BpcCommon.Api.getSetting(this.moduleId, dashboard.assets.ConfigKeys.columns) || 3;
    this.items = this.createDashboard();
    this.callParent();
    me.applicationToolbarLeft = Ext.create('Ext.toolbar.Toolbar', {moduleId:me.moduleId, moduleInstance:me, viewModel:{parent:vm}, items:[{xtype:'tbspacer', width:10}, {xtype:'bpcDashboardLeftToolbarHook', context:{moduleId:'dashboard', instanceId:me.moduleId}}]});
    this.applicationToolbarRight = this.createApplicationToolbar();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}, recreateDashboard:function() {
  if (this.isVisible(true)) {
    BpcCommon.Api.showModule(this.moduleId, true);
    this.destroy();
  } else {
    if (!this.recreationScheduled) {
      this.recreationScheduled = true;
      this.on('show', this.recreateDashboard, this);
    }
  }
}, createDashboard:function() {
  var colLayoutConfig;
  var columns = this.numberOfColumns;
  var layout = BpcCommon.Api.getSetting(this.moduleId, dashboard.assets.ConfigKeys.colLayout);
  if (Ext.isArray(layout) && layout.length === this.numberOfColumns) {
    var sumWidth = 0;
    Ext.Array.each(layout, function(layoutObj) {
      if (!layoutObj.columnWidth || layoutObj.columnWidth < 0.1) {
        layoutObj.columnWidth = 0.1;
      } else if (layoutObj.columnWidth > 1) {
        layoutObj.columnWidth = 1;
      }
      sumWidth = sumWidth + layoutObj.columnWidth;
    });
    Ext.Array.each(layout, function(layoutObj) {
      layoutObj.columnWidth = Ext.Number.correctFloat(layoutObj.columnWidth / sumWidth);
    });
    colLayoutConfig = layout;
  } else {
    colLayoutConfig = [];
    Ext.log('using fallback column calc');
    for (var i = 0; i < columns; i++) {
      colLayoutConfig.push({columnWidth:1 / columns});
    }
  }
  var dbColumns = [];
  for (var columnIndex = 0; columnIndex < this.numberOfColumns; columnIndex++) {
    var column = {xtype:'dbColumn', columnWidth:colLayoutConfig[columnIndex].columnWidth, columnIndex:columnIndex, reference:'column' + columnIndex, moduleId:this.moduleId, items:[Ext.apply(this.getPlaceholder(), {columnIndex:columnIndex})], margin:'0 10 0 0'};
    if (columnIndex + 1 === this.numberOfColumns) {
      column.margin = 0;
    }
    dbColumns.push(column);
  }
  var panelConfig = {xtype:'panel', layout:'column', ui:'transparent', scrollable:true, items:dbColumns};
  var responsive = BpcCommon.Api.getSetting(this.moduleId, dashboard.assets.ConfigKeys.responsive);
  if (responsive && responsive === true) {
    Ext.apply(panelConfig, {layout:{type:'hbox', align:'stretch'}, defaults:{flex:1}});
  }
  return [panelConfig];
}, createApplicationToolbar:function() {
  return Ext.create({xtype:'toolbar', layout:{pack:'end'}, viewModel:this.getViewModel(), defaults:{ui:'apptoolbardefault'}, overflowHandler:'scroller', items:[{xtype:'bpcDashboardRightToolbarHook', context:{moduleId:'dashboard', instanceId:this.moduleId}}, {iconCls:BpcCommon.Icons.WARNING + ' warningColor', localized:{text:'DASHBOARD_UNSAVED_CHANGES'}, bind:{hidden:'{!unsavedChanges}'}, handler:this.getController().saveState, scope:this.getController()}, {xtype:'splitbutton', iconCls:BpcCommon.Icons.ADD, 
  localized:{tooltip:'DASHBOARD_WIDGET_ADD'}, handler:this.getController().openSelectorWindow, scope:this.getController(), hidden:true, bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashbaord + '}'}, menu:{plain:true, items:[{localized:{text:'DASHBOARD_DASHBOARD_ADD', tooltip:'DASHBOARD_DASHBOARD_ADD'}, iconCls:dashboard.assets.Icons.DASHBOARD, handler:this.getController().createDashboard, scope:this.getController()}, {localized:{text:'DASHBOARD_WIDGET_ADD', tooltip:'DASHBOARD_WIDGET_ADD'}, 
  iconCls:dashboard.assets.Icons.WIDGET, handler:this.getController().openSelectorWindow, scope:this.getController()}]}}, {xtype:'button', iconCls:BpcCommon.Icons.SAVE, localized:{tooltip:'CORE_SAVE'}, handler:this.getController().saveState, scope:this.getController(), hidden:true, bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashbaord + '}'}}, {xtype:'splitbutton', itemId:'btnAutoRefresh', iconCls:dashboard.assets.Icons.autoRefreshIcon + ' bpcPlay', localized:{tooltip:'CORE_REFRESH'}, handler:this.getController().refreshAllWidgets, 
  scope:this.getController(), menu:{width:200, plain:true, items:[{xtype:'menucheckitem', checked:true, hideOnClick:true, clickHideDelay:50, localized:{text:'DASHBOARD_REFRESH_AUTO'}, handler:this.getController().onAutoRefresh, scope:this.getController()}]}, hidden:true, bind:{hidden:'{!' + dashboard.assets.ConfigKeys.toolbarRefresh + '}'}}]});
}, getPlaceholder:function() {
  Ext.log(this.self.getName() + ': getPlaceholder');
  return {xtype:'dbWidgetWrapperPlaceHolder'};
}, setSettingToVMandSettingPanel:function(settingName) {
  Ext.log({msg:this.self.getName() + ': setSettingToVM', level:'info'});
  try {
    var settingModel = BpcCommon.Api.getSetting(this.moduleId, settingName, true);
    this.settings.push(settingModel);
    this.getViewModel().set(settingName, settingModel.get('value'));
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR setSettingToVMandSettingPanel', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('dashboard.view.MainController', {extend:'Ext.app.ViewController', alias:'controller.dashboardMainController', stateProviderPrefix:'bpcDashboard-', control:{'*':{widgetConfigurationChange:{fn:'setDirty', options:{args:[true]}}}}, ready:false, init:function() {
  var me = this;
  try {
    me.configurationSetting = BpcCommon.Api.getSetting(me.getView().moduleId, 'configuration', true);
    if (!me.configurationSetting) {
      return;
    }
    me.stateProviderPrefix = me.stateProviderPrefix + me.getView().moduleId + '-';
    var configuration = me.configurationSetting.get('value');
    if (Ext.isArray(configuration) && configuration.length > 0) {
      configuration.forEach(function(config) {
        return me.addWidget(config, true);
      });
      me.configurationSetting.set('value', configuration);
    }
    me.autoRefreshTask = Ext.TaskManager.newTask({run:me.autoRefreshTask.bind(me), interval:1000 * 30});
    me.autoRefreshTask.start();
    me.ready = true;
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR init', dump:e, stack:true, level:'error'});
  }
}, destroy:function() {
  if (this.autoRefreshTask) {
    this.autoRefreshTask.stop();
  }
  this.callParent();
}, autoRefreshTask:function() {
  try {
    var autoRefresh = !this.getViewModel().get('autoUpdate');
    if (autoRefresh && !BpcCommon.Api.hasWebsocketConnection()) {
      this.refreshAllWidgets();
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR autoRefreshTask', dump:e, stack:true, level:'error'});
  }
}, widgetSelectorWindow:null, openSelectorWindow:function(btn) {
  var columnIndex = null;
  if (Ext.isDefined(btn.columnIndex)) {
    columnIndex = btn.columnIndex;
  }
  Ext.create('BpcCommon.component.window.Window', {localized:{title:'DASHBOARD_WIDGET_ADD'}, layout:'fit', iconCls:dashboard.assets.Icons.WIDGET, height:550, width:850, resizable:true, constrain:true, items:[{xtype:'dashboardWidgetSelection', stayOpen:false, moduleId:this.getView().moduleId, columnIndex:columnIndex}]}).show();
}, resetUserState:function(source) {
  var widgetWrapper = source.up('dbWidgetWrapper');
  if (widgetWrapper) {
    var baseConfig = widgetWrapper.baseConfig;
    Ext.state.Manager.set(this.stateProviderPrefix + widgetWrapper.persistenceId);
    var column = widgetWrapper.up('dbColumn');
    var currentIndex = column.items.indexOf(widgetWrapper);
    this.setDirty(true);
    widgetWrapper.destroy();
    widgetWrapper = this.addWidget(baseConfig);
    var refItem = column.items.getAt(currentIndex);
    if (refItem && refItem !== widgetWrapper) {
      column.moveBefore(widgetWrapper, refItem);
    }
  }
}, saveState:function() {
  var me = this;
  try {
    if (!BpcCommon.Api.hasUserRight(dashboard.assets.ModuleRights.editDashbaord)) {
      BpcCommon.Api.showNotification('CORE_ERROR_MISSING_RIGHT');
      return;
    }
    var columns = me.getView().query('dbColumn');
    var newConfiguration = [];
    Ext.each(columns, function(column) {
      var columnIndex = column.columnIndex;
      column.items.each(function(widgetWrapper) {
        if (widgetWrapper.widgetId) {
          newConfiguration.push({widgetId:widgetWrapper.widgetId, className:widgetWrapper.baseConfig.className, column:columnIndex, height:widgetWrapper.height, widgetConfiguration:widgetWrapper.widget ? widgetWrapper.widget.getWidgetConfiguration() : {}, persistenceId:widgetWrapper.persistenceId});
          me.removeWidgetFromConfiguration(widgetWrapper);
        }
      });
    });
    newConfiguration = newConfiguration.concat(me.configurationSetting.get('value'));
    me.configurationSetting.set('value', newConfiguration);
    me.configurationSetting.save({success:function() {
      BpcCommon.Api.showNotification.bind(BpcCommon.Api, 'DASHBOARD_SAVE_SUCCESSFUL');
      me.setDirty(false);
      Ext.fireEvent('dashboardWidgetConfigSaved');
    }, failure:BpcCommon.Api.showNotification.bind(BpcCommon.Api, 'DASHBOARD_SAVE_FAILED')});
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': saveState ERROR', dump:e, stack:true, level:'error'});
  }
}, addWidget:function(baseConfig, silent) {
  try {
    var className = baseConfig.className || baseConfig.widgetId;
    var position = baseConfig.column || 0;
    var height = baseConfig.height;
    var configObj = baseConfig.widgetConfiguration || {};
    var moduleId = this.getView().moduleId;
    var targetColumn = this.lookupReference('column' + position);
    baseConfig.persistenceId = baseConfig.persistenceId || (new Date()).getTime();
    var widgetId = baseConfig.widgetId || baseConfig.persistenceId;
    baseConfig.widgetId = widgetId;
    if (targetColumn) {
      var widgetState = Ext.state.Manager.get(this.stateProviderPrefix + baseConfig.persistenceId);
      var widgetConfiguration = configObj;
      var userCustom = false;
      if (widgetState && Ext.isObject(widgetState)) {
        widgetConfiguration = Ext.applyIf(widgetState, widgetConfiguration);
        userCustom = true;
      }
      var widget = BpcCommon.Api.getWidgetComponent(widgetId, {className:className, columnIndex:position, widgetConfiguration:widgetConfiguration, listeners:{scope:this, widgetConfigurationChange:this.saveLocalWidgetConfiguration}, persistenceId:baseConfig.persistenceId});
      baseConfig.className = widget.className;
      var numberOfWidgetsInColumn = targetColumn.query('dbWidgetWrapper').length;
      var widgetWrapper = targetColumn.add({xtype:'dbWidgetWrapper', widgetId:widgetId, columnIndex:position, moduleId:moduleId, height:height, items:[widget], persistenceId:baseConfig.persistenceId, userCustom:userCustom, baseConfig:baseConfig, margin:numberOfWidgetsInColumn < 1 ? 0 : '8 0 0 0'});
      if (silent !== true) {
        this.setDirty(true);
      }
      var placeholder = targetColumn.down('dbWidgetWrapperPlaceHolder');
      if (placeholder) {
        targetColumn.remove(placeholder);
      }
      return widgetWrapper;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': addWidget ERROR', dump:e, stack:true, level:'error'});
  }
}, saveLocalWidgetConfiguration:function(widgetCmp) {
  try {
    if (widgetCmp && widgetCmp.persistenceId && widgetCmp.isBpcWidget && widgetCmp.rendered) {
      Ext.state.Manager.set(this.stateProviderPrefix + widgetCmp.persistenceId, widgetCmp.getWidgetConfiguration());
      var wrapper = widgetCmp.up('dbWidgetWrapper');
      if (wrapper) {
        wrapper.getViewModel().set('customizedByUser', true);
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR saveLocalWidgetConfiguration', dump:e, stack:true, level:'error'});
  }
}, moveWidget:function(header, columnOffset) {
  try {
    var widgetWrapper = header.up('dbWidgetWrapper');
    var dashboard$0 = this.getView();
    var targetColumn = widgetWrapper.columnIndex + columnOffset;
    if (targetColumn >= 0 && targetColumn < dashboard$0.numberOfColumns) {
      var widgetConfig = widgetWrapper.baseConfig;
      widgetConfig.column = targetColumn;
      this.addWidget(widgetConfig);
      widgetWrapper.close();
    }
    this.setDirty(true);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR moveWidget', dump:e, stack:true, level:'error'});
  }
}, moveWidgetLeft:function(header) {
  this.moveWidget(header, -1);
}, moveWidgetRight:function(header) {
  this.moveWidget(header, 1);
}, removeWidgetWrapper:function(source) {
  try {
    var widget = source.up('dbWidgetWrapper');
    this.removeWidgetFromConfiguration(widget);
    this.setDirty(true);
    widget.close();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR closeWidgetWrapper', dump:e, stack:true, level:'error'});
  }
}, removeWidgetFromConfiguration:function(widget) {
  if (widget.persistenceId) {
    var configuration = this.configurationSetting.get('value');
    var widgetConfigEntry = Ext.Array.findBy(configuration, function(configItem) {
      return BpcCommon.Util.isStringEqual(widget.persistenceId, configItem.persistenceId);
    });
    if (widgetConfigEntry) {
      configuration = Ext.Array.remove(configuration, widgetConfigEntry);
      this.configurationSetting.set('value', configuration);
    }
  }
}, moveWidgetUp:function(header) {
  try {
    var widget = header.up('dbWidgetWrapper');
    var column = widget.up('dbColumn');
    var currentIndex = column.items.indexOf(widget);
    var refItem = column.items.getAt(currentIndex - 1);
    column.moveBefore(widget, refItem);
    this.setDirty(true);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR moveWidgetUp', dump:e, stack:true, level:'error'});
  }
}, moveWidgetDown:function(header) {
  try {
    var widget = header.up('dbWidgetWrapper');
    var column = widget.up('dbColumn');
    var currentIndex = column.items.indexOf(widget);
    var refItem = column.items.getAt(currentIndex + 1);
    column.moveAfter(widget, refItem);
    this.setDirty(true);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR moveWidgetDown', dump:e, stack:true, level:'error'});
  }
}, refreshAllWidgets:function() {
  try {
    var dbWrapperArray = this.getView().query('dbWidgetWrapper');
    if (dbWrapperArray.length > 0) {
      Ext.Array.each(dbWrapperArray, function(dbWrapper) {
        var btnArr = dbWrapper.getHeader().query('#refreshWidgetBtn');
        if (btnArr.length > 0) {
          btnArr[0].fireHandler();
        }
      });
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR refreshAllWidgets', dump:e, stack:true, level:'error'});
  }
}, onAutoRefresh:function(checkitem) {
  try {
    var splitBtn = checkitem.up('splitbutton');
    var cssCls = splitBtn.iconCls;
    var autoUpdate = null;
    if (checkitem.checked !== true) {
      cssCls = cssCls.replace('bpcPlay', 'bpcPause');
      splitBtn.setIconCls(cssCls);
      autoUpdate = false;
    }
    if (checkitem.checked === true) {
      cssCls = cssCls.replace('bpcPause', 'bpcPlay');
      splitBtn.setIconCls(cssCls);
      autoUpdate = true;
    }
    this.getViewModel().set('autoUpdate', autoUpdate);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onAutoRefresh', dump:e, stack:true, level:'error'});
  }
}, configWidget:function(header) {
  var widgetWrapper = header.up('dbWidgetWrapper');
  var widget = widgetWrapper.items.getAt(0);
  if (widget.configureWidget) {
    widget.configureWidget();
  } else {
    Ext.log('Widget does not support configWidget, method not implemented.');
  }
}, refreshWidget:function(header) {
  try {
    var widgetWrapper = header.up('dbWidgetWrapper');
    var widget = widgetWrapper.items.getAt(0);
    if (widget.refreshWidget) {
      widget.refreshWidget();
    } else {
      Ext.log('Widget does not support refresh, method not implemented.');
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR refreshWidget', dump:e, stack:true, level:'error'});
  }
}, createDashboard:function() {
  try {
    if (BpcCommon.Api.getLicenseInformationForKey('MODULE_DASHBOARD_CONFIGURE') === false) {
      BpcCommon.Api.showNotification(BPC.assets.Strings.notLicensedNotifictation);
      return;
    }
    BpcCommon.Api.createInstanceWithGui('dashboard');
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createDashboard', dump:e, stack:true, level:'error'});
  }
}, setDirty:function(dirty) {
  var me = this;
  var dirtyState = Ext.isBoolean(dirty) ? dirty : true;
  me.getViewModel().set('unsavedChanges', dirtyState);
}, widgetJumpToModule:function(btn) {
  try {
    var wrapper = btn.up('dbWidgetWrapper');
    var moduleIdHolder = wrapper.down('[moduleId]');
    if (moduleIdHolder) {
      var params = Ext.isFunction(moduleIdHolder.getJumpParams) ? moduleIdHolder.getJumpParams() : undefined;
      BpcCommon.Api.showModule(moduleIdHolder.moduleId, false, params);
    } else {
      BpcCommon.Api.showNotification(BpcCommon.lang.Current.DASHBOARD_MODULE_NOT_FOUND);
    }
  } catch (e) {
    Ext.log({msg:': ERROR handler', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('dashboard.view.wrapper.WidgetWrapper', {extend:'Ext.panel.Panel', alias:'widget.dbWidgetWrapper', layout:'fit', title:'Dashboard Widget', resizable:true, resizeHandles:'s', frame:true, iconCls:'x-fal', viewModel:{data:{title:BpcCommon.lang.Current.DASHBOARD_WIDGET_TITLE, tooltip:BpcCommon.lang.Current.DASHBOARD_WIDGET_TOOLTIP, customizedByUser:false, hasConfiguration:false, allowWidgetMove:false}}, header:{items:[{xtype:'button', iconCls:BpcCommon.Icons.INFO, bind:{tooltip:'{tooltip}', 
hidden:'{!' + dashboard.assets.ConfigKeys.widgetInfo + '}'}, itemId:'wrapperInfo', moduleId:undefined}, {xtype:'button', iconCls:BpcCommon.Icons.LINK, tooltip:BpcCommon.lang.Current.DASHBOARD_GOTO_MODULE, itemId:'wrapperInstanceLink', bind:{hidden:'{!' + dashboard.assets.ConfigKeys.widgetJump + '}'}, handler:'widgetJumpToModule'}, {xtype:'button', iconCls:'x-fal fa-arrows', arrowVisible:false, menu:{items:[{iconCls:'x-fal fa-arrow-up', text:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE_UP, handler:'moveWidgetUp'}, 
{iconCls:'x-fal fa-arrow-down', text:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE_DOWN, handler:'moveWidgetDown'}, {iconCls:'x-fal fa-arrow-left', text:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE_LEFT, handler:'moveWidgetLeft'}, {iconCls:'x-fal fa-arrow-right', text:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE_RIGHT, handler:'moveWidgetRight'}]}, bind:{hidden:'{!allowWidgetMove}'}, tooltip:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE}, {xtype:'button', iconCls:BpcCommon.Icons.REFRESH, handler:'refreshWidget', 
bind:{hidden:'{!' + dashboard.assets.ConfigKeys.widgetRefresh + '}'}, itemId:'refreshWidgetBtn', tooltip:BpcCommon.lang.Current.CORE_REFRESH}, {xtype:'button', iconCls:BpcCommon.Icons.SETTING, bind:{hidden:'{!hasConfiguration}'}, handler:'configWidget', tooltip:BpcCommon.lang.Current.CORE_SETTINGS}, {xtype:'button', iconCls:BpcCommon.Icons.USER_REMOVE, bind:{hidden:'{!customizedByUser}'}, handler:'resetUserState', tooltip:BpcCommon.lang.Current.DASHBOARD_USER_STATE_RESET}, {xtype:'button', iconCls:BpcCommon.Icons.DELETE, 
handler:'removeWidgetWrapper', bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashbaord + '}'}, tooltip:BpcCommon.lang.Current.DASHBOARD_REMOVE_WIDGET}]}, additionalWidgetActions:undefined, isInitialised:false, initComponent:function() {
  try {
    var vm = this.getViewModel();
    vm.set('allowWidgetMove', vm.get(dashboard.assets.ModuleRights.editDashbaord) && vm.get(dashboard.assets.ConfigKeys.widgetMove));
    var responsive = BpcCommon.Api.getSetting(this.moduleId, dashboard.assets.ConfigKeys.responsive);
    if (responsive && responsive === true) {
      this.height = null;
      this.flex = 1;
    }
    if (this.userCustom === true) {
      this.getViewModel().set('customizedByUser', true);
    }
    this.callParent();
    this.updateWrapperData(this, this.items.first());
    this.on('add', this.updateWrapperData, this);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}, updateWrapperData:function(wrapper, newCmp) {
  try {
    if (newCmp && newCmp.isBpcWidget) {
      this.widget = newCmp;
      var widgetConfig = Ext.clone(newCmp.getWidgetConfiguration());
      if (this.isInitialised === false) {
        if (Ext.isArray(widgetConfig.additionalActions) && widgetConfig.additionalActions.length !== 0) {
          Ext.defer(function() {
            this.addCustomTools(widgetConfig.additionalActions);
          }.bind(this), 100);
        }
      }
      if (widgetConfig.title || widgetConfig.name) {
        var title = BpcCommon.Api.getTranslation(widgetConfig.title || widgetConfig.name);
        this.setTitle(title);
      }
      if (widgetConfig.tooltip || widgetConfig.description) {
        var iconIconTooltip = BpcCommon.Api.getTranslation(widgetConfig.tooltip || widgetConfig.description);
        if (widgetConfig.moduleId && Ext.isDefined(widgetConfig.moduleId)) {
          var moduleInstanceName = BpcCommon.Api.getSetting(widgetConfig.moduleId, 'module_name');
          if (Ext.isDefined(moduleInstanceName)) {
            iconIconTooltip += '\x3cbr\x3e' + moduleInstanceName;
          }
        }
        this.getViewModel().set('tooltip', iconIconTooltip);
      }
      if (widgetConfig.iconCls) {
        this.setIconCls(widgetConfig.iconCls);
        Ext.defer(function(iconCls) {
          this.setIconCls('reset');
          this.setIconCls(iconCls);
        }, 100, this, [widgetConfig.iconCls]);
      }
      if (!newCmp.widgetWrapper) {
        newCmp.widgetWrapper = this;
        newCmp.on('widgetConfigurationChange', this.updateWrapperData.bind(this, this, newCmp));
      }
      this.getViewModel().set('hasConfiguration', Ext.isFunction(this.widget.configureWidget));
      this.isInitialised = true;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateWrapperData', dump:e, stack:true, level:'error'});
  }
}, addCustomTools:function(additionalActions) {
  var me = this;
  var header = undefined;
  try {
    header = me.getHeader();
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR can not find header', dump:e, stack:true, level:'error'});
  }
  var actionScope = me.down('[isBpcWidget\x3dtrue]');
  if (!actionScope || !header) {
    return;
  }
  if (Ext.isArray(header.items)) {
    header.items = header.items.filter(function(item) {
      return item.isAdditionalAction === undefined;
    });
  }
  var defaultAction = {xtype:'button', iconCls:BpcCommon.Icons.ERROR, handler:Ext.emptyFn, isAdditionalAction:true};
  Ext.each(additionalActions, function(action) {
    action.handler = action.handler.bind(actionScope);
    Ext.applyIf(action, defaultAction);
    if (header instanceof Ext.panel.Header || Ext.isFunction(header.insert)) {
      header.insert(1, action);
    } else if (Ext.isArray(header.items)) {
      header.items.unshift(action);
    }
  });
}});
Ext.define('dashboard.view.Placeholder', {extend:'dashboard.view.wrapper.WidgetWrapper', alias:'widget.dbWidgetWrapperPlaceHolder', margin:'10 0 0 0', height:250, layout:{type:'vbox', pack:'center', align:'middle'}, items:[{xtype:'button', iconCls:BpcCommon.Icons.ADD, handler:'openSelectorWindow', bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashbaord + '}'}}, {xtype:'box', html:'\x3ch3\x3e' + BpcCommon.lang.Current.DASHBOARD_WIDGET_ADD_DESCRIPTION + '\x3c/h3\x3e'}], initComponent:function() {
  Ext.log(this.self.getName() + ': initComponent');
  try {
    this.callParent();
    if (Ext.isDefined(this.columnIndex)) {
      this.down('button').columnIndex = this.columnIndex;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('dashboard.view.selector.WidgetSelectionController', {extend:'Ext.app.ViewController', alias:'controller.dashboardWidgetSelectionController', addWidget:function() {
  Ext.log({msg:this.self.getName() + ': addWidget'});
  try {
    var grid = this.lookupReference('widgetGrid');
    var position = this.lookupReference('positionField').getValue() - 1;
    var selection = grid.getSelection();
    if (selection.length > 0) {
      var widgetModel = selection[0];
      var targetDashboard = Ext.ComponentQuery.query('dbMain[moduleId\x3d' + this.getView().moduleId + ']')[0];
      targetDashboard.getController().addWidget({className:widgetModel.get('className'), column:position});
      if (!this.getView().stayOpen) {
        this.getView().up('window').close();
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR addWidget', dump:e, stack:true, level:'error'});
  }
}, close:function() {
  Ext.log({msg:this.self.getName() + ': close'});
  try {
    this.getView().up('window').close();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR close', dump:e, stack:true, level:'error'});
  }
}, onAddMoreChange:function(field) {
  var value = field.getValue();
  this.getView().stayOpen = value;
}});
Ext.define('dashboard.view.selector.WidgetSelection', {extend:'Ext.panel.Panel', alias:'widget.dashboardWidgetSelection', requires:['dashboard.view.selector.WidgetSelectionController'], controller:'dashboardWidgetSelectionController', layout:'card', viewModel:{data:{columnIndex:1, maxValue:3, minValue:1}}, moduleId:undefined, columnIndex:undefined, buttons:[{xtype:'bpcGridFilterField', width:150, grid:'^ panel grid'}, '-\x3e', {xtype:'numberfield', width:120, labelWidth:50, localized:{fieldLabel:'CORE_COLUMN'}, 
reference:'positionField', bind:{value:'{columnIndex}', maxValue:'{maxValue}', minValue:'{minValue}'}}, {xtype:'checkbox', localized:{boxLabel:'CORE_ADD_MORE'}, listeners:{change:'onAddMoreChange'}}, {iconCls:BpcCommon.Icons.CANCEL, ui:'secondary', localized:{text:'CORE_CANCEL'}, handler:'close'}, {iconCls:BpcCommon.Icons.ADD, ui:'primary', localized:{text:'CORE_ADD'}, handler:'addWidget'}], items:[{xtype:'box', style:'display: flex;justify-content: center;align-items: center;', localized:{html:{tpl:'\x3ci class\x3d"fa fa-spinner fa-pulse fa-5x fa-fw"\x3e\x3c/i\x3e\x3cbr\x3e\x3cspan\x3e{CORE_INSTANCE_LOADING}\x3c/span\x3e', 
keys:['CORE_INSTANCE_LOADING']}}}, {xtype:'grid', reference:'widgetGrid', cls:'widgetGrid', viewConfig:{markDirty:false}, itemId:'widgetGrid', store:BpcCommon.Api.getWidgetStore(), selModel:{selType:'checkboxmodel', mode:'SINGLE'}, columns:[{text:' ', dataIndex:'iconCls', width:35, renderer:function(value) {
  return '\x3ci class\x3d"fa ' + value + '" aria-hidden\x3d"true"\x3e\x3c/i\x3e';
}}, {localized:{text:'CORE_NAME'}, dataIndex:'name', flex:3, cellWrap:true, renderer:function(value, metaData, record) {
  var name = BpcCommon.Api.getTranslation(record.data.name);
  var description = BpcCommon.Api.getTranslation(record.data.description);
  return '\x3cspan data-qtip\x3d"' + name + '"\x3e' + name + '\x3c/span\x3e\x3cbr/\x3e' + ("\x3cspan style\x3d'opacity: .8' data-qtip\x3d\"" + description + '"\x3e' + description + '\x3c/span\x3e');
}}, {localized:{text:'CORE_MODULE_NAME'}, dataIndex:'module', flex:1, listeners:{afterrender:function(cmp) {
  cmp.sort('ASC');
}}}]}], selectionGrid:undefined, initComponent:function() {
  Ext.log({msg:this.self.getName() + ': initComponent'});
  try {
    this.callParent();
    if (Ext.isDefined(this.columnIndex) && this.columnIndex !== null) {
      this.getViewModel().set('columnIndex', this.columnIndex + 1);
    }
    var numberOfColumns = BpcCommon.Api.getSetting(this.moduleId, 'numberOfColumns');
    this.getViewModel().set('maxValue', numberOfColumns);
    BpcCommon.Api.loadAllModules().then(this.setActiveItem.bind(this, 'widgetGrid'));
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('dashboard.view.toolbar.PluginHookLeft', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.bpcDashboardLeftToolbarHook', layout:{type:'hbox', align:'middle'}, inheritableStatics:{NAME:'Dashboard Toolbar links', HOOK_ID:'dashboard_toolbar_left'}});
Ext.define('dashboard.view.toolbar.PluginHookRight', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.bpcDashboardRightToolbarHook', layout:{type:'hbox', align:'middle'}, inheritableStatics:{NAME:'Dashboard Toolbar rechts', HOOK_ID:'dashboard_toolbar_right'}});
